For a fun 20 minutes or so, I recommend going through the recent enron “revival”. (It’s all satire)
Only Bayes Can Judge Me
For a fun 20 minutes or so, I recommend going through the recent enron “revival”. (It’s all satire)
Before reading the story I guessed that he had used chatgpt as a search engine and I was right! My best case scenario: law enforcement pushes for backdoors into chatgpt and poisons the codebase forever.
I did end up writing a code solution.
So basically the problem boils down to this:
A 1 bit full adder circuit with carry in/out is described as follows:
Si = Xi ^ Yi ^ Cini
Couti = (Xi && Yi) || (Cini && (Xi ^ Yi))
Where S is the output bit, X and Y are the input bits, and Cini is the carry out bit of bit i-1. For the first and last bits of the output, the circuits are slightly different due to carry in/out not mattering in the 0/last bit case.
Note that as said in the problem statement any input is correctly labelled, while outputs might be incorrect. You can then categorise each gate input/output as any of the elements in an adder circuit. You can then use set differences and intersections to determine the errors between categories. That’s all you need to do!
For example, you might have something like:
X && Y = err
if this output was used correctly, it should show up as an operand to an OR gate. So if you did:
(Set of all outputs of and gates) - (Set of all inputs to or gates), if something appears, then you know one of the and gates is wrong.
Just exhaustively find all the relevant differences and intersections and you’re done! To correct the circuit, you can then just brute force the 105 combinations of pair swaps to find what ends up correcting the circuit.
I did part 2 manually! I will not bother writing a code solution unless I feel like it.
AoC, so you thought you could dredge up my trauma as an EE grad by making me debug a full-adder logic circuit? How dare you. You succeeded.
I’ve probably learned that term at some point, so thanks for naming it. That made me realise my algorithm was too thicc and could just be greedy.
22
pretty straightforward. At least it’s not a grid!
21!
Finally managed to beat this one into submission.
I created this disgusting mess of a recursive search that happened to work. This problem was really hard to think about due to the levels of indirection. It was also hard because of a bug I introduced into my code that would have been easy to debug with more print statements, but hubris.
Recursive solution from P1 was too slow, once I was at 7 robots it was taking minutes to run the code. It didn’t take long to realise that you don’t really care about where the robots other than the keypad robot and the one controlling the keypad robot are since the boundary of each state needs all the previous robots to be on the A button. So with memoisation, you can calculate all the shortest paths for a given robot to each of the directional inputs in constant time, so O(kn) all up where n is the number of robots (25) and k is the complexity of searching for a path over 5 or 11 nodes.
What helped was looking at the penultimate robot’s button choices when moving the keypad robot. After the first one or two levels, the transitions settle into the table in the appendix. I will not explain the code.
(P(0, 1), P(0, 1)): [],
(P(0, 1), P(0, 2)): [btn.r],
(P(0, 1), P(1, 0)): [btn.d, btn.l],
(P(0, 1), P(1, 1)): [btn.d],
(P(0, 1), P(1, 2)): [btn.d, btn.r],
(P(0, 2), P(0, 1)): [btn.l],
(P(0, 2), P(0, 2)): [],
(P(0, 2), P(1, 0)): [btn.d, btn.l, btn.l],
(P(0, 2), P(1, 1)): [btn.l, btn.d],
(P(0, 2), P(1, 2)): [btn.d],
(P(1, 0), P(0, 1)): [btn.r, btn.u],
(P(1, 0), P(0, 2)): [btn.r, btn.r, btn.u],
(P(1, 0), P(1, 0)): [],
(P(1, 0), P(1, 1)): [btn.r],
(P(1, 0), P(1, 2)): [btn.r, btn.r],
(P(1, 1), P(0, 1)): [btn.u],
(P(1, 1), P(0, 2)): [btn.u, btn.r],
(P(1, 1), P(1, 0)): [btn.l],
(P(1, 1), P(1, 1)): [],
(P(1, 1), P(1, 2)): [btn.r],
(P(1, 2), P(0, 1)): [btn.l, btn.u],
(P(1, 2), P(0, 2)): [btn.u],
(P(1, 2), P(1, 0)): [btn.l, btn.l],
(P(1, 2), P(1, 1)): [btn.l],
(P(1, 2), P(1, 2)): [],
1.1 trillion? Good luck, chuck.
21 (wip)
Understandable, have a nice day
It took me too long to read the prompt and see that without the shortcuts, it’s a single path. I wasted too much time on search algorithms.
P1: Here’s what I did: Walk the path. Every time you hit a new grid, check if the two shortcuts you can take will save you 100 ps.
To calculate the shortcut saving:
If you index every grid position on the main path from 0, then it takes X ps to reach position X, The time it takes to travel from start to X, then a shortcut to Y, then from Y to the end, is X + 1 + (main path length - Y). The time saved is then just Y - X - 1, modulo maybe like 5 fence post errors.
P2. The prompt wasn’t really clear about whether or not cheating meant you can only travel through one set of walls before your cheat ends, or if it meant you could just move through walls for 20ps to wherever you could reach. Turns out, it’s the latter.
The above formula is then a special case of Y - X - manhattan distance(X, Y).
20: currently a WIP but:
Wait, so it’s all grids? 🧑🏿🚀🔫🧑🏿🚀
Day 19! (the cuervo gold…)
Ok so my path to this answer was circuitous and I now hate myself a little.
P1: Ok, a repeated dfs on suffixes. that shouldn’t be too hard. (it was not hard)
P2: Ok, a repeated dfs is a little too slow for me, I wonder how I can speed it up?
forgets about memoisation, a thing that you can do to speed this sort of thing up
I guess the problem is I’m doing an O(mn) match (where m is the number of towels, n is the max towel length) when I can do O(n). I’ll build a prefix tree!
one prefix tree later
Ok that still seems to be quite slow. What am I doing wrong?
remembers that memoisation exists
Oh I just need to memoise my dp from part 1. Oops.
Anyway posting the code because I shrunk it down to like two semicolons worth of lines.
(
List<String> input = getLines();
Set<String> ts = Set.from(input.first.split(', '));
Map<String, int> dp = {};
int dpm(String s) => dp.putIfAbsent(
s,
() => s.isNotEmpty
? ts
.where((t) => t.matchAsPrefix(s) != null)
.map((t) => dpm(s.substring(t.length)))
.fold(0, (a, b) => a + b)
: 1);
void d19(bool sub) {
print(input
.skip(2)
.map((s) => dpm(s))
.map((i) => sub
? i
: i > 0
? 1
: 0)
.reduce((a, b) => a + b));
}
gilding the lily a bit but
What is this, day 16?
Does a sealion have bootlicker nature? Ugh.
Please, señor software engineer was my father. Call me Bob.
17!
Simultaneously very fun and also the fucking worst.
Fun: Ooooh, I get to simulate a computer, exciting!
Worst: Literally 8 edge cases where fucking up even just one can fuck up your hour.
I did this by hand. sort of. I mean I didn’t code up something that found the answer.
Basically I looked at the program in the input and wrote it out, and realised that A was essentially a loop variable, where the number of iterations was the number of octal digits A would take to represent. The most significant octal digits (octits?) would determine the tail end of the output sequence, so to find the smallest A you can do a DFS starting from the MS octit. I did this by hand.
class Comp {
List<int> reg;
List<int> prog;
int ip = 0;
List<int> output = [];
late List<(int, bool) Function()> ops;
int get combo => prog[ip + 1] < 4 ? prog[ip + 1] : reg[prog[ip + 1] - 4];
Comp(this.reg, this.prog) {
ops = [
() => (reg[0] = (reg[0] >> combo), false),
() => (reg[1] ^= prog[ip + 1], false),
() => (reg[1] = combo % 8, false),
() => (reg[0] != 0) ? (ip = prog[ip + 1], true) : (0, false),
() => (reg[1] ^= reg[2], false),
() {
output.add(combo % 8);
return (0, false);
},
() => (reg[1] = (reg[0] >> combo), false),
() => (reg[2] = (reg[0] >> combo), false)
];
}
compute() {
output.clear();
while (ip < prog.length) {
if (!ops[prog[ip]]().$2) {
ip += 2;
}
}
}
reset(int A) {
ip = 0;
reg[0] = A;
reg[1] = 0;
reg[2] = 0;
}
}
void d17(bool sub) {
List<String> input = getLines();
Comp c = Comp(
input.take(3).map((s) => s.split(" ").last).map(int.parse).toList(),
input.last.split(" ").last.split(",").map(int.parse).toList())
..compute();
print("Part a: ${c.output.join(",")}");
if (!sub) return;
List<int> sols = [];
bool dfs(int cur) {
bool found = false;
sols.add(cur);
int sol = sols.reduce((a, b) => 8 * a + b);
c..reset(sol)..compute();
if (c.prog
.whereIndexed((i, e) => i >= c.prog.length - c.output.length)
.foldIndexed(true, (i, p, e) => p && c.output[i] == e)) {
if (found = c.output.length == c.prog.length) {
print("Part b: $sol");
} else {
for (int i = 0; i < 8 && !(found = found || dfs(i)); i++) {}
}
}
sols.removeLast();
return found;
}
for (int a = 0; a < 8 && !dfs(a); a++) {}
}
Oof ouch